/*
	vpdctl.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "vpd.h"

LOCAL	TC	DrvName[] = {
	TK_v, TK_p, TK_d, TK_QSTN, TK_NULL,
};
LOCAL	TC	CtlName[] = {
	TK_v, TK_p, TK_d, TK_c, TK_t, TK_l, TK_QSTN, TK_NULL,
};

#define	DRVCHAR	3	/* DrvNameΡTK_QSTNΰ */
#define	CTLCHAR	6	/* CtlNameΡTK_QSTNΰ */

/* ɥ쥹֤ȥå */
EXPORT	ERR	taskspace_select(DrvWork *wk, DevReq *q)
{
	ERR	err;
	W	size;

	/* ɥ쥹֤ꡦåɬ̵ */
	if (!q->cmd.adcnv || q->datacnt <= 0) {
		err = ER_OK;
		goto fin0;
	}

	/* ɥ쥹֤ */
	err = SetTaskSpace(q->taskid);
	if (err < ER_OK) {
		D(("taskspace_select: SetTaskSpace %d\n", err));
		goto fin0;
	}

	/* å٤ΰΥ׻ */
	size = q->datacnt;
	if (q->datano >= 0 && wk->c_diskinfo.blocksize) {
		size *= wk->c_diskinfo.blocksize;
	}

	/* ɥ쥹֤Υå */
	err = (q->cmd.cmd == DC_READ) ?
		CheckSpaceRW(q->memptr, size) : CheckSpaceR(q->memptr, size);

	if (err < ER_OK) {
		D(("taskspace_select: CheckSpaceR(W) %d\n", err));
	}

 fin0:
	return err;
}

/* ξõ */
EXPORT	void	clear_partinfo(DrvWork *wk)
{
	memset(&wk->c_partinfo[1], 0, sizeof(VPD_PARTINFO) * MAX_PARTINFO);
	return;
}

/* ɤ߹ */
EXPORT	ERR	load_partinfo(DrvWork *wk)
{
	ERR	err;
	W	rsz;
	DevDef	dd;
	DEV_STATE	ds;
	VPD_HEADER	*h;

	/* ǥХ°μ */
	err = b_dev_sts(wk->c_name, &ds);
	if (err < ER_OK) {
		D(("load_partinfo: b_dev_sts %d\n", err));
		goto fin0;
	}

	/* Ƭ˽񤫤Ƥ */
	err = b_rea_dev(wk->c_dd, 0, wk->c_buf, 1, &rsz, NULL);
	if (err < ER_OK) {
		D(("load_partinfo: b_rea_dev %d\n", err));
		goto fin0;
	}

	/* μ */
	wk->c_partinfo[0].systemid   = DSID_BTRON;	/* 1ʾ */
	wk->c_partinfo[0].startblock = 0;
	wk->c_partinfo[0].endblock   = wk->c_diskinfo.blockcont - 1;
	wk->c_partinfo[0].reserved   = 0;
	clear_partinfo(wk);

	/* إåγǧ */
	h = check_header(wk->c_buf, MAX_PARTINFO, wk->c_diskinfo.blocksize);

	/* إå̵꤬硢 */
	if (h != NULL) {
		import_partinfo(wk->c_buf, &wk->c_partinfo[1],
				MAX_PARTINFO, wk->c_diskinfo.blocksize);
		check_partinfo(&wk->c_partinfo[1], MAX_PARTINFO,
			       1,	/* ơ֥ȽŤʤäƤϤʤ */
			       wk->c_partinfo[0].endblock);
	}

#ifdef	DEBUG
	disp_partinfo(wk->c_partinfo, MAX_PARTINFO + 1);
#endif

	/* ǥХι */
	memset(&dd, 0, sizeof(dd));
	dd.attr.devinfo  = wk->drvno;
	dd.attr.devkind  = ds.attr & DA_DEVKIND;
	dd.attr.reserved = 0;		/* ͽ(0) */
	dd.attr.openreq  = 0;
	dd.attr.lockreq  = 0;		/* lock */
	dd.attr.diskinfo = 1;		/* diskinfoб */
	dd.attr.chardev  = 0;		/* block device */
	dd.attr.nowait   = 0;		/* nowaitб */
	dd.attr.eject    = 0;		/* ejectб */
	dd.subunits      = MAX_PARTINFO;
	DrvName[DRVCHAR] = TK_a + wk->drvno;
	memcpy(dd.name, DrvName, sizeof(DrvName));
	dd.portid        = wk->d_porid;

	err = b_DefDevice(&dd, &wk->c_diskinfo);
	if (err < ER_OK) {
		D(("load_partinfo: b_DefDevice %d\n", err));
		goto fin0;
	}
	wk->d_devid = err;

	err = ER_OK;

 fin0:
	return err;
}

/* Ͽ */
LOCAL	ERR	ctl_attach(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	err, rsz;
	DiskEvt	evt;

	/* attachѤ */
	if (wk->c_dd >= 0) {
		D(("ctl_attach: already attached\n"));
		err = ER_BUSY;
		goto fin0;
	}

	/* ڥɶػߡʥڥɤػߤ */
	b_sus_dev(D_FORCE | D_DISSUS);

	/* ǥХ̾򥳥ԡ */
	memcpy(wk->c_name, q->memptr, (q->datacnt < sizeof(wk->c_name)) ?
	       q->datacnt : sizeof(wk->c_name));

	/* åȤopen */
	err = b_opn_dev(wk->c_name, D_UPDATE | D_EXCL, NULL);
	if (err < ER_OK) {
		D(("ctl_attach: b_opn_dev %d\n", err));
		goto fin1;
	}
	wk->c_dd = err;

	/* ǥμ */
	err = b_rea_dev(wk->c_dd, DN_DISKINFO, (UB *)&wk->c_diskinfo,
			sizeof(wk->c_diskinfo),	&rsz, NULL);
	if (err < ER_OK) {
		D(("ctl_attach: b_rea_dev %d\n", err));
		goto fin2;
	}

	/* Хåեγ */
	wk->c_buf = Kmalloc(wk->c_diskinfo.blocksize * BUFSECT);
	if (wk->c_buf == NULL) {
		D(("ctl_attach: Kmalloc NULL\n", err));
		err = ER_NOMEM;
		goto fin2;
	}

	/* ɤ߹ߤȡǥХι */
	err = load_partinfo(wk);
	if (err < ER_OK) {
		D(("ctl_attach: load_partinfo %d\n", err));
		goto fin3;
	}

	/* ɬפ˱ΤԤ */
	if (wk->mbfid) {
		evt.kind  = DE_MOUNT;
		evt.devid = wk->d_devid;
		evt.info  = 0;

		err = tsnd_mbf(wk->mbfid, &evt, sizeof(evt), TMO_POL);
		if (err < ER_OK) {
			D(("ctl_attach: tsnd_mbf %d\n", err));
		}
	}

	err = ER_OK;
	goto fin0;

 fin3:
	Kfree(wk->c_buf);
	wk->c_buf = NULL;
 fin2:
	b_cls_dev(wk->c_dd, 0, NULL);
	wk->c_dd = -1;
 fin1:
	b_sus_dev(D_FORCE | D_ENASUS);
 fin0:
	return err;
}

/*  */
LOCAL	ERR	ctl_detach(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	err, i;
	DiskEvt	evt;

	/* åȤ³Ƥʤ硢äԲ */
	if (wk->c_dd < 0) {
		D(("ctl_detach: already detached\n"));
		err = ER_NOMDA;
		goto fin0;
	}

	/* ߻ζ褬¸ߤ硢äԲ */
	for (i = MAX_PARTINFO; i >= 0 && !wk->d_openflag[i]; i--);
	if (i >= 0) {
		D(("ctl_detach: busy\n"));
		err = ER_BUSY;
		goto fin0;
	}		

	/* Хåեβ */
	Kfree(wk->c_buf);
	wk->c_buf = NULL;

	/* åȤΥ */
	b_cls_dev(wk->c_dd, 0, NULL);
	wk->c_dd = -1;

	/* ڥɵ */
	b_sus_dev(D_FORCE | D_ENASUS);

	/* ɬפ˱ΤԤ */
	if (wk->mbfid) {
		evt.kind  = DE_EJECT;
		evt.devid = wk->d_devid;
		evt.info  = 0;

		err = tsnd_mbf(wk->mbfid, &evt, sizeof(evt), TMO_POL);
		if (err < ER_OK) {
			D(("ctl_detach: tsnd_mbf %d\n", err));
		}
	}

	err = ER_OK;
 fin0:
	return err;
}

/* write׵ */
LOCAL	ERR	ctl_write(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;

	switch (q->datano) {
	case	DN_VPDATTACH:	return ctl_attach(wk, q, r);
	case	DN_VPDDETACH:	return ctl_detach(wk, q, r);
	default:		return ER_PAR;
	}
}

/* ³ΥǥХ̾ */
LOCAL	ERR	ctl_attach_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	err;

	/* åȤ³Ƥʤ硢Բ */
	if (wk->c_dd < 0) {
		D(("ctl_attach_read: already detached\n"));
		err = ER_NOMDA;
		goto fin0;
	}

	/* ǥХ̾򥳥ԡ */
	memcpy(q->memptr, wk->c_name, (q->datacnt < sizeof(wk->c_name)) ?
	       q->datacnt : sizeof(wk->c_name));

	err = ER_OK;
 fin0:
	return err;
}

/* read׵ */
LOCAL	ERR	ctl_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;

	switch (q->datano) {
	case	DN_VPDATTACH:	return ctl_attach_read(wk, q, r);
	default:		return ER_PAR;
	}
}

/* Ƽ׵ */
LOCAL	ERR	ctl_request(DrvWork *wk, DevReq *q, DevRsp *r)
{
	switch (q->cmd.cmd) {
		/* ̾׵ */
	case	DC_READ:	return ctl_read(wk, q, r);
	case	DC_WRITE:	return ctl_write(wk, q, r);

	case	DC_OPEN:
	case	DC_CLOSE:
	case	DC_CLOSEALL:	return ER_OK;

		/* ü׵ */
	case	DC_ABORT:
	case	DC_SUSPEND:
	case	DC_RESUME:	return ER_OK;

		/* ¾ */
	default:		return ER_NOSPT;
	}
}

/* ǥХϿ */
LOCAL	ERR	ctl_regist(DrvWork *wk)
{
	WERR	err;
	DevDef	dd;

	/* ǥХϿ */
	memset(&dd, 0, sizeof(dd));
	dd.attr.devinfo  = wk->drvno;
	dd.attr.devkind  = DK_UNDEF;	/* äʤ */
	dd.attr.reserved = 0;		/* ͽ(0) */
	dd.attr.openreq  = 0;		/* open/close򤽤𤷤ʤ */
	dd.attr.lockreq  = 0;		/* lock */
	dd.attr.diskinfo = 0;		/* diskinfo̵ */
	dd.attr.chardev  = 1;		/* character device */
	dd.attr.nowait   = 0;		/* nowaitб */
	dd.attr.eject    = 0;		/* ejectб */
	dd.subunits      = 0;		/* subunit̵ */
	CtlName[CTLCHAR] = TK_a + wk->drvno;
	memcpy(dd.name, CtlName, sizeof(CtlName));
	dd.portid        = wk->c_porid;

	err = b_DefDevice(&dd, NULL);
	if (err < ER_OK) {
		D(("ctl_start: b_DefDevice %d\n", err));
		goto fin0;
	}
	wk->c_devid = err;

 fin0:
	return err;
}

/* ɥ饤С */
EXPORT	void	ctl_task(UW calptn)
{
	ERR	err;
	RNO	rno;
	W	size;
	T_RTSK	rtsk;
	DevReq	q;
	DevRsp	r;
	DrvWork	*wk;

	/* μ */
	err = ref_tsk(&rtsk, TSK_SELF);
	if (err < ER_OK) {
		D(("ctl_task: ref_tsk %d\n", err));
		goto fin0;
	}
	wk = rtsk.exinf;

	/* ꥢ */
	wk->c_buf = NULL;
	wk->c_dd = -1;

	/* ǥХϿ */
	err = ctl_regist(wk);
	if (err < ER_OK) {
		D(("ctl_task: ctl_regist %d\n", err));
		goto fin0;
	}

	while (1) {
		/* ׵Ԥ*/
		err = acp_por(&rno, (VP)&q, &size, wk->c_porid, calptn);
		if (err < ER_OK) {
			goto fin1;
		}

		/* ¹ */
		Lock(&wk->lock);

		/* ѥåȥΥå̵ʤ饿ڤؤ */
		err = (size != sizeof(q)) ? ER_PAR : taskspace_select(wk, &q);

		/* ѥѥåȤν׵μ¹ */
		r.devid     = q.devid;
		r.cmd       = q.cmd;
		r.datano    = q.datano;
		r.datacnt   = 0;
		r.error.err = (err < ER_OK) ? err : ctl_request(wk, &q, &r);

		/* ǥ֤ؤ */
		err = rpl_rdv(rno, (VP)&r, sizeof(r));
		if (err < ER_OK) {
			D(("ctl_task: rpl_rdv %d\n", err));
		}

		/* ¹Դλ */
		Unlock(&wk->lock);
	}

 fin1:
	if (wk->c_buf != NULL) {
		Kfree(wk->c_buf);
		wk->c_buf = NULL;
	}
	if (wk->c_dd >= 0) {
		b_cls_dev(wk->c_dd, 0, NULL);
		wk->c_dd = -1;
		b_sus_dev(D_FORCE | D_ENASUS);
	}
	del_por(wk->c_porid);
 fin0:
	exd_tsk();
}
